/**
 * Created by Mai on 2017/4/1.
 */
var ration_glj = {
    createNew: function (project) {
        // 用户定义private方法
        var tools = {};

        // 所有通过this访问的属性，都不应在此单元外部进行写入操作
        var ration_glj = function (proj) {
            this.gljTree = cacheTree.createNew(this);
           // this.project = proj;
            this.datas = [];

            var sourceType = ModuleNames.ration_glj;
            this.getSourceType = function () {
                return sourceType;
            }
            proj.registerModule(ModuleNames.ration_glj, this);
        };

        // 从后台获取数据
        /*glj.prototype.pullData = function (){
            this.project.pullData(
                '/glj/getData',
                {projectID: this.project.ID},
                function(result){
                    if (result.error ===0){
                        this.loadDatas(result.data);
                    }
                    else {
                        // to do: 错误处理需要细化
                        alert(result.message);
                    }
                },
                function (){}//to do: 错误处理需要细化
            )
        };*/
        // prototype用于定义public方法
        ration_glj.prototype.loadData = function (datas) {
            this.datas = datas;
        };

        ration_glj.prototype.getGljArrByRation = function (rationID) {
            return this.datas.filter(function (data) {
                return data.rationID === rationID;
            })
        };
        ration_glj.prototype.getGatherGljArrByRations = function (rations) {
            let result = [];
            let clone = function (obj) {
                if (obj === null) return null;

                var o = Object.prototype.toString.apply(obj) === "[object Array]" ? [] : {};
                for (var i in obj) {
                    o[i] = (obj[i] instanceof Date) ? new Date(obj[i].getTime()) : (typeof obj[i] === "object" ? clone(obj[i]) : obj[i]);
                }
                return o;
            }
            let findGlj = function (sourceGlj, gljArr) {
                for (let glj of gljArr) {
                    if (glj.projectGLJID === sourceGlj.projectGLJID) {
                        return glj;
                    }
                }
                return null;
            }
            for (let ration of rations) {
                let rationGljs = this.getGljArrByRation(ration.ID);
                for (let glj of rationGljs) {
                    let sameGlj = findGlj(glj, result);
                    if (!sameGlj) {
                        sameGlj = clone(glj);
                        sameGlj.quantity = (sameGlj.quantity * ration.quantity).toDecimal(4);
                        result.push(sameGlj);
                    } else {
                        sameGlj.quantity = sameGlj.quantity + (glj.quantity * ration.quantity).toDecimal(4);
                    }
                }
            }
            return result;
        }

        // 提交数据后返回数据处理
        ration_glj.prototype.doAfterUpdate = function(err, data){
            if(!err){
                if(data.updateTpye=='ut_update'){
                    this.refreshAfterUpdate(data);
                }else if(data.updateTpye=='ut_delete'){
                    this.refreshAfterDelete(data);
                } else {
                    this.refreshAfterSave(data);
                }
            }
        };
        ration_glj.prototype.refreshAfterSave=function(data){
            let neRecodes=[];
            if(data){
                neRecodes=data.newRecords;
                gljOprObj.sheetData=data.showDatas;
            }
            if(projectObj.project.ration_glj.datas&&Array.isArray(projectObj.project.ration_glj.datas)){
                if(data){
                    projectObj.project.ration_glj.datas = projectObj.project.ration_glj.datas.concat(neRecodes);
                }
            }else {
                projectObj.project.ration_glj.datas = neRecodes;
            }
            gljOprObj.showRationGLJSheetData();
        };
        ration_glj.prototype.refreshAfterUpdate=function(data){
            var me = this;
            if(data.quantityRefresh){
                data.glj_result.forEach(function (item) {
                    me.refreshEachItme(item.doc,item.query);
                })
            }else {
                me.refreshEachItme(data.doc,data.query);
            }
            gljOprObj.showRationGLJSheetData();
        };
        ration_glj.prototype.refreshEachItme = function (doc,query) {
            var glj_list = projectObj.project.ration_glj.datas;
            var glj_index= _.findIndex(glj_list,(glj)=>{
                return glj.ID==query.ID;
            })
            var sheet_index= _.findIndex(gljOprObj.sheetData,(sd)=>{
                return sd.ID==query.ID;
            })
            _.forEach(doc, function(n, key) {
                glj_list[glj_index][key] = n;
                gljOprObj.sheetData[sheet_index][key]=n;
            });
            return glj_list[glj_index].rationID;
        };
        ration_glj.prototype.refreshAfterDelete=function(data){
            var glj_list = projectObj.project.ration_glj.datas;
            _.remove(glj_list,data.query);
            _.remove(gljOprObj.sheetData,data.query);
            gljOprObj.showRationGLJSheetData();
        };
        // CSL,2017.05.09
        ration_glj.prototype.modifyQuantity = function (data, newQuantity) {
            this.project.beginUpdate('modifyQuantity');
            data.quantity = newQuantity;
            data.customQuantity = newQuantity;
            data.updateType = 'ut_update';
            this.project.push(this.getSourceType, data);
            this.project.endUpdate();
        };

        ration_glj.prototype.modifyPrice = function (data, newPrice) {
            this.project.beginUpdate('modifyPrice');
            data.price = newPrice;
            data.updateType = 'ut_update';
            this.project.push(this.getSourceType, data);
            this.project.endUpdate();
        };

        ration_glj.prototype.deleteGLJ = function (data) {
            this.project.beginUpdate('deleteGLJ');
            data.customQuantity = 0;
            data.quantity = 0;
            data.rationItemQuantity = 0;
            data.updateType = 'ut_update';
            this.project.push(this.getSourceType, data);
            this.project.endUpdate();
        };

        ration_glj.prototype.replaceGLJ = function (data, newGLJID) {
            this.project.beginUpdate('replaceGLJ');
            data.GLJID = newGLJID;
            data.updateType = 'ut_update';
            this.project.push(this.getSourceType, data);
            this.project.endUpdate();
        };

        ration_glj.prototype.addRationGLJ = function (newRation,data) {
            var souceTypeList=[];
            var criteriaDataList = [];
            if(data.hasOwnProperty('rationGljList')&&data.rationGljList.length>0){
                let criteria= {};
                criteria.ration_glj_list = [];
                for(let i=0;i<data.rationGljList.length;i++){
                    let temdata = data.rationGljList[i];
                    let newGLJ = {};
                    newGLJ.projectID = newRation.projectID;
                    newGLJ.GLJID = temdata.gljId;
                    newGLJ.rationID = newRation.ID;
                    newGLJ.rationItemQuantity= temdata.consumeAmt;
                    newGLJ.quantity=temdata.consumeAmt;
                    newGLJ.glj_repository_id=data.rationRepId;
                    criteria.ration_glj_list.push(newGLJ);
                }
                criteria.updateType = 'ut_create';
                souceTypeList.push(this.getSourceType());
                criteriaDataList.push(criteria);
            }
            var ration_coe = projectObj.project.ration_coe;
            var rationCoeData = ration_coe.getRationCoedata(newRation,data);
            souceTypeList.push(ration_coe.getSourceType());
            criteriaDataList.push(rationCoeData);
            project.pushNow('addRationGLJAndRationCoe',souceTypeList,criteriaDataList);

        };

        ration_glj.prototype.getDeleteDataByRation=function(rationData){
            var updateData = [];
            updateData.push({'deleteType':'RATION','updateType': 'ut_delete', 'updateData': {'ID': rationData.ID, 'projectID': rationData.projectID}});
            return updateData;
        };
        ration_glj.prototype.getDeleteDataByBills=function(datas){
            var updateData = [];
            datas.forEach(function (deleteData) {
                if(deleteData.type=='delete'){
                    var billData = deleteData.data;
                    updateData.push({'deleteType':'BILL','updateType': 'ut_delete', 'updateData': {'ID': billData.ID, 'projectID': billData.projectID}});
                }
            })
            return updateData;
        };
        ration_glj.prototype.deleteByRation = function(ration){
            var glj_list = projectObj.project.ration_glj.datas;
            var newList =_.filter(glj_list,(glj)=>{
               return glj.rationID!=ration.ID;
            });
            if(newList!=undefined){
                projectObj.project.ration_glj.datas = newList;
            }
        };
        ration_glj.prototype.deleteByBills=function(deleteData){
            var rationList = projectObj.project.Ration.datas;
            var deleteRationList = [];
            for(var i=0;i<deleteData.length;i++){
                if(deleteData[i].type=='delete'){
                    var billID = deleteData[i].data.ID;
                    var raList =_.filter(rationList,(ration)=>{
                        return ration.billsItemID==billID;
                    });
                    deleteRationList = deleteRationList.concat(raList);
                }
            }
            for(var i=0;i<deleteRationList.length;i++){
                this.deleteByRation(deleteRationList[i]);
                projectObj.project.ration_coe.deleteByRation(deleteRationList[i]);
                projectObj.project.quantity_detail.deleteByRation(deleteRationList[i]);
                projectObj.project.Ration.datas.splice(projectObj.project.Ration.datas.indexOf(deleteRationList[i]), 1);
            }
        }

        ration_glj.prototype.updataOrdelete=function(row){
            var updateData = null;
            if(row.rationItemQuantity==0){
                updateData=this.getUpdateData('ut_delete',{'ID': row.ID, 'projectID': row.projectID});
                project.pushNow('updateRationGLJ',[this.getSourceType()],updateData)
            }else {
                this.customQuantityUpdate(row,0,0);//('ut_update',{'ID': row.ID, 'projectID': row.projectID},{'quantity':0,'customQuantity':0});
            }
        };
        ration_glj.prototype.getUpdateData=function(type,query,doc,callfunction){
            var updateData = [];
            var newobj = {
                'updateType': type,
                'query': query,
            }
            if(doc){
                newobj['doc']=doc;
            }
            if(callfunction){
                newobj['updateFunction']=callfunction;
            }
            updateData.push(newobj);
            return updateData;
        };
        ration_glj.prototype.customQuantityUpdate = function(recode,newVal,text){
            newVal = _.round(newVal,3);
            var query = {
                'ID':recode.ID,
                'projectID': recode.projectID,
                'rationID':recode.rationID
            };
            var doc;
            if(text===null){
                doc ={
                    customQuantity:null
                };
            }else {
                doc ={
                    customQuantity:newVal,
                    quantity:newVal
                };
            }


            var updateData = this.getUpdateData('ut_update',query,doc,'customQuantityUpdate');
            project.pushNow('updateRationGLJ',[this.getSourceType()],updateData);

        };
        ration_glj.prototype.marketPriceAdjustUpdate = function (recode,newVal,text) {
            newVal = _.round(newVal,2);
            if(text===null){
                newVal=null;
            }
            var query = {
                'ID':recode.ID,
                'projectID': recode.projectID,
                'rationID':recode.rationID
            };
            var doc ={
                base_price:Number(recode.basePrice),
                market_price:newVal,
                code:recode.code,
                name:recode.name,
                project_id:recode.projectID,
                repositoryId:recode.repositoryId
            };
         /*   code: '01010101',
                market_price: '40',
                name: '水泥',
                project_id: projectId*/
            var updateData = this.getUpdateData('ut_update',query,doc,'marketPriceAdjustUpdate');
            project.pushNow('updateRationGLJ',[this.getSourceType()],updateData);
        };

        return new ration_glj(project);
    }
};